window.addEventListener('load', function(event) {

    time = new Date();
    //time = new Date(2020, 9, 11, 17, 30, 00);

    updateTimestring();
    updateTimeline();

    buttonShowAll();
    //document.getElementById("btn-all").click();
    

    setInterval(
        function(){
            time = new Date();

            updateTimeline();
            updateTimestring();

        }, 1000);

    document.getElementById("btn-all").addEventListener("click", function() {buttonShowAll()});
    document.getElementById("btn-lectures").addEventListener("click", () => buttonLectures());
    document.getElementById("btn-practices").addEventListener("click", buttonPractices);
    
    let nlist = document.querySelectorAll(".lecture, .practice");
    nlist.forEach(n => {
        n.addEventListener("click", showNotes);
    });

    //open event is not available
    document.querySelectorAll("dialog").forEach(n => {n.addEventListener("close", () => {document.body.classList.remove("blur")})});

    document.getElementById("notes-button").addEventListener("click", hideNotes);
    
})


window.addEventListener("resize", updateTimeline());





function buttonShowAll() {
    var el = document.getElementsByClassName("lecture");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.add("highlight");
    }

    el = document.getElementsByClassName("practice");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.add("highlight");
    }
}

function buttonLectures() {
    var el = document.getElementsByClassName("lecture");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.add("highlight");
    }

    el = document.getElementsByClassName("practice");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.remove("highlight");
    }
}

function buttonPractices() {
    var el = document.getElementsByClassName("lecture");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.remove("highlight");
    }

    el = document.getElementsByClassName("practice");
    for (let i = 0; i < el.length; i++) {
        el[i].classList.add("highlight");
    }
}




function updateTimestring()
{
    document.getElementById("clock").innerText = time.toLocaleString();
}


function updateTimeline()
{
    
    if(typeof time === "undefined") return;

    var td = getTdId(time);

    if(typeof td === "undefined")
    {
        console.log("Out of schedule");
        document.getElementById("timer").style.display = "none";
    }
    else 
    {
        document.getElementById("timer").style.display = "block";

        //identification of TD
        document.getElementById("timer").style.top = document.getElementById(td).getBoundingClientRect().top + "px";
        document.getElementById("timer").style.height = document.getElementById(td).getBoundingClientRect().height + "px";

        //position inside TD
        var width = document.getElementById(td).getBoundingClientRect().width + 20; //right boder
        var minutesinlesson = ((time.getHours()*60 + time.getMinutes()) - (60 * 7 + 15)) % 105;
        document.getElementById("timer").style.left = document.getElementById(td).getBoundingClientRect().left + (width / 105.0 * minutesinlesson) - 2 + "px";
    }
}


function getTdId(d = new Date())
{
    
    var day;
    var lesson;
    switch(d.getDay())
    {
        case 0: day = "su"; break;
        case 1: day = "mo"; break;
        case 2: day = "tu"; break;
        case 3: day = "we"; break;
        case 4: day = "th"; break;
        case 5: day = "fr"; break;
        case 6: day = "sa"; break;
    }

    lesson = getLessonNumber(d);

    return day+lesson;

}

function getLessonNumber(d)
{
    // 1 - 7:15, 2 - 9:00, 3 - 10:45, 4 - 12:30, 5 - 14:15, 6 - 16:00

    var d2 = new Date();
    d2.setFullYear(d.getFullYear(), d.getMonth(), d.getDate());

    d2.setHours(7); d2.setMinutes(15);
    if(d < d2) lesson = 0;
    if(d >= d2) lesson = 1;
    d2.setHours(9); d2.setMinutes(0); d2.setSeconds(0); d2.setMilliseconds(0);
    if(d >= d2) lesson = 2;
    d2.setHours(10); d2.setMinutes(45);d2.setSeconds(0);d2.setMilliseconds(0);
    if(d >= d2) lesson = 3;
    d2.setHours(12); d2.setMinutes(30);d2.setSeconds(0);d2.setMilliseconds(0);
    if(d >= d2) lesson = 4;
    d2.setHours(14); d2.setMinutes(15);d2.setSeconds(0);d2.setMilliseconds(0);
    if(d >= d2) lesson = 5;
    d2.setHours(16); d2.setMinutes(0);d2.setSeconds(0);d2.setMilliseconds(0);
    if(d >= d2) lesson = 6;
    d2.setHours(17); d2.setMinutes(45);d2.setSeconds(0);d2.setMilliseconds(0);
    if(d > d2) lesson = 0;

    if(lesson == 0) return undefined;
    return lesson;

}


function showNotes(e)
{
    document.body.classList.add("blur");

    console.log(e);
    
    var i = findTDId(e.target)
    document.getElementById("notes-id").value = i;
    document.getElementById("notes-text").value = localStorage.getItem(i);
    document.getElementById("notes").showModal();
}

function hideNotes(e)
{
    let id = document.getElementById("notes-id").value;
    let text = document.getElementById("notes-text").value;

    localStorage.setItem(id, text);
    document.getElementById("notes").close();

}

function findTDId(el)
{
    if(el.localName == "td") return el.id;
    else
        if(el.parentNode == document)
            return null;
        else
            return findTDId(el.parentNode);
    
}